#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_BulletCFG.h"
std::auto_ptr<Fish_BulletCFG> Fish_BulletCFG::msSingleton(nullptr);

int Fish_BulletCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_BulletCFGData* Fish_BulletCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_BulletCFGData>& Fish_BulletCFG::GetMapData()
{
	return mMapData;
}

void Fish_BulletCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_BulletCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_BulletCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mBulletType = element->IntAttribute("BulletType");
		data.mResType = element->IntAttribute("ResType");
		data.mResName = element->Attribute("ResName");
		data.mColor = element->IntAttribute("Color");
		data.mScale = element->FloatAttribute("Scale");
		{
			const char* Collider = element->Attribute("Collider");
			std::vector<std::string> vecCollider;
			boost::split(vecCollider, Collider, boost::is_any_of(","));
			float temp;
			for (unsigned int i = 0; i < vecCollider.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToFloat(vecCollider[i].c_str(), &temp))
				{
					data.mCollider.push_back(temp);
				}
			}
		}
		data.mBulletCount = element->IntAttribute("BulletCount");
		data.mHitType = element->IntAttribute("HitType");
		data.mHitEffectID = element->IntAttribute("HitEffectID");
		data.mHitSoundID = element->IntAttribute("HitSoundID");
		data.mNetEffect = element->IntAttribute("NetEffect");
		data.mNetSize = element->IntAttribute("NetSize");
		data.mNetScale = element->FloatAttribute("NetScale");
		data.mNetCount = element->IntAttribute("NetCount");
		data.mNetHitCount = element->IntAttribute("NetHitCount");
		data.mSpeed = element->IntAttribute("Speed");
		{
			const char* Param = element->Attribute("Param");
			std::vector<std::string> vecParam;
			boost::split(vecParam, Param, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecParam[i].c_str(), &temp))
				{
					data.mParam.push_back(temp);
				}
			}
		}
		data.mRadius = element->FloatAttribute("Radius");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_BulletCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BulletCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_BulletCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_BulletCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_BulletCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "BulletType", data.mBulletType);
		LuaCfgHelper::readInt(L, "ResType", data.mResType);
		LuaCfgHelper::readString(L, "ResName", data.mResName);
		LuaCfgHelper::readInt(L, "Color", data.mColor);
		LuaCfgHelper::readFloat(L, "Scale", data.mScale);
		LuaCfgHelper::readVectorFloat(L, "Collider", data.mCollider);
		LuaCfgHelper::readInt(L, "BulletCount", data.mBulletCount);
		LuaCfgHelper::readInt(L, "HitType", data.mHitType);
		LuaCfgHelper::readInt(L, "HitEffectID", data.mHitEffectID);
		LuaCfgHelper::readInt(L, "HitSoundID", data.mHitSoundID);
		LuaCfgHelper::readInt(L, "NetEffect", data.mNetEffect);
		LuaCfgHelper::readInt(L, "NetSize", data.mNetSize);
		LuaCfgHelper::readFloat(L, "NetScale", data.mNetScale);
		LuaCfgHelper::readInt(L, "NetCount", data.mNetCount);
		LuaCfgHelper::readInt(L, "NetHitCount", data.mNetHitCount);
		LuaCfgHelper::readInt(L, "Speed", data.mSpeed);
		LuaCfgHelper::readVectorInt(L, "Param", data.mParam);
		LuaCfgHelper::readFloat(L, "Radius", data.mRadius);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_BulletCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_BulletCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_BulletCFG* Fish_BulletCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_BulletCFG());
	}
	return msSingleton.get();
}

void Fish_BulletCFG::Release()
{
	msSingleton.reset(nullptr);
}
